/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm                                          
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|   
|   Foundation, Inc., 
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|  
|
|                   getcolumn.c REV 3 for SQL Query Generator
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|  
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
#include "querygen.h"


sqltable *getcolumn( FILE *fp )
{



       static sqltable column, *p_column;      //one is the struct and the other is the pointer that is returned
       int i;                                                // i is for counting in loops
       char *p_ctqbuf;                                //this holds the string that skipcomment gets
       char ctqbuf[MAX];                            //use this to copy p_ctqbuf into for things that we need an array for
       char ucase[MAX];                            //upper case buffer(easier to use for checking for types)



        //set these to 1 when their corresponding struct member gets a value
        int name_done = 0, type_done = 0, null_done = 0;



        //initialize pointer to column
        p_column = &column;


    //clear the structure before continuing
    memset(&column, 0, sizeof(column));




                                       


while ( (p_ctqbuf = skipcomment(fp)) != NULL ) {

           

               
  
  //some stuff(like the for loop below) needs an array not a pointer
  strcpy(ctqbuf, p_ctqbuf);
  strcpy(ucase, p_ctqbuf);

  //make the ucase buffer upper case
  for(i = 0; i < MAX; i++) {

        ucase[i] = toupper(ucase[i]);

  }


  /* look for the word "CREATE".
  if it is found, then return 0 because
  that means we are done w/ the previous table

  if this is the last table in the CREATE TABLE query
  file, the word CREATE wont be found, but skipcomment()
  will return NULL causing the loop here to end returning 0
  */
  if(strstr(ucase, "CREATE"))
  return 0;


/*===========================CHAR==NCHAR==NVARCHAR==========================*/

    if( strstr(ucase, "CHAR") ) {

         sprintf(column.type, "CHAR");
         type_done = 1;


    }

/*===================================BIT================================*/



    if( strstr(ucase, "BIT")) {

          sprintf(column.type, "BIT");
          type_done = 1;

    }



 /*===================================DECIMAL===============================*/



    if( strstr(ucase, "DECIMAL")) {

          sprintf(column.type, "DECIMAL");
          type_done = 1;

    }



/*===================================SMALLINT=================================*/

    if( strstr(ucase, "SMALLINT") ) {

         sprintf(column.type, "SMALLINT");
         type_done = 1;


    }


/*===================================TINYINT=================================*/

    if( strstr(ucase, "TINYINT") ) {

         sprintf(column.type, "TINYINT");
         type_done = 1;


    }



/*===================================INT==INTEGER==========================*/



    if( strstr(ucase, "INT") ) {

          sprintf(column.type, "INTEGER");
          type_done = 1;

    }



/*=================================== FLOAT ================================*/

    if( strstr(ucase, "FLOAT")) {

          sprintf(column.type, "FLOAT");
          type_done = 1;

    }


/*===================================VARCHAR================================*/


     if( strstr(ucase, "VARCHAR") ) {

           sprintf(column.type, "VARCHAR");
           type_done = 1;

     }


/*===================================NOT NULL================================*/




    
    //if the name and type have been found, look for the end of the line or end of the CREATE TABLE query
    if( (name_done == 1 && type_done == 1) && (strchr(p_ctqbuf, ',') != NULL ||  strchr(p_ctqbuf, ';') != NULL) )
       {

           if( strchr(p_ctqbuf, ',') && strchr(p_ctqbuf, ';'))  //if both a comma and semicolon were found, then
            {                                                                 //there is an error in the CREATE TABLE query file
               fprintf(stderr, "\nError in your CREATE TABLE query file\n");
               exit(1);
            }
       
            //if the column can contain a NULL value then set
            //column.null to 0
           column.null = 0;
           null_done = 1;
       }




     if( strstr(ucase, "NOT")) {
        
        if( (p_ctqbuf = skipcomment(fp)) != NULL) {
                 strcpy(ucase, p_ctqbuf);

                 //make the ucase buffer upper case
                 for(i = 0; i < MAX; i++) {
                 ucase[i] = toupper(ucase[i]);
                 }


                 //now check to see if the next word is "NULL"
                 if( strstr(ucase, "NULL")) {
                    column.null = 1;
                    null_done = 1;

                 }

        }


  }





/*=============================================================================*/




   //if it wasn't any of the above,or a comma then it must be the column name
    if( name_done == 0)//(type_done == 0) && (null_done == 0))
    {

           //check for reserved words
          if( chkres(p_ctqbuf) == 1)
          {
             fprintf(stderr, "\nERROR getcolumn.c: %s is a reserverd word.\n", p_ctqbuf);
             exit(1);
          }


           //just so the program doesnt get told that '(' is the column name
           if( strchr(p_ctqbuf, '(') == NULL)
             {
               sprintf(column.name, "%s", p_ctqbuf);
               name_done = 1;
             }

     }
     


         if(strchr(p_ctqbuf,';') )
            {
                 if(null_done == 0)  //make sure null_done gets set to 1 so the last column doesnt get skipped
                 { null_done = 1; column.null =0; }
                 
              
                //return 0;
             }



    if( name_done != 0 && type_done != 0 && null_done != 0)
    {

     

      //  else{ return p_column; }

        return p_column;
        
      }





    

    }   //end of while loop


  return 0;

}
