/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|
|   Foundation, Inc.,
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|
|
|                   main.c  REV 6  for SQL Query Generator
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "querygen.h"


void show_usage(char *progname );

int main(int argc, char *argv[])
{



    extern char out[MAX];
    extern char ctqfile[MAX];
    char option, call_function;
    char longoption[MAX];
    int i, optioncount = 0;
    int longoption_ch;
    extern int appendfile; //the option for appending a file
    extern int printstdout;
    extern int useoutputfile; //1: use the output file | 0: no output file used (only --print-stdout)

     //this only gets set to 0 when argc == 4
     useoutputfile = 1;



   if( (argc > 6) || (argc < 3) )
   {
     show_usage( argv[0]);
   }



for(i = 1; i < argc; i++)
{

   optioncount = 0;

   //now check to see if the option starts with the '-'
   if(argv[i][0] == '-')
       while( isalpha(argv[i][++optioncount]) != 0)
       {
            //argv[1][1] contains the letter after the '-'
            option = argv[i][optioncount];

             //the option switch
             switch(option)
             {

                 case 'i':
                   call_function = argv[i][optioncount];
                   break;

                 case 'u':
                   call_function = argv[i][optioncount];
                   break;

                  case 'd':
                    call_function = argv[i][optioncount];
                    break;

                  case 'a':
                    appendfile = 1;  //option for appending the output file
                    break;

                   case 'p':
                     printstdout = 1;
                     break;

                   default:

                     show_usage( argv[0] );
                     break;

             }

         } //end while(isspace(argv[i][++optioncount]) != 0)


/////////////////////////////////////////   L O N G    O P T I O N S   ///////////////////////////////////////////////////////////////////

   //  long options
  if(argv[i][0] == '-' && argv[i][1] == '-')
  {


       optioncount = 1; // long options use two dashes, so setting this to 1 will skip the
                              //first two dashes when ++optioncount is done in the while loop below


       longoption_ch = 0; //make sure to start at the beginning of the array


        //when checking ispunct() dont use ++optioncount because it is already incremented
       while(  (isalpha(argv[i][++optioncount]) != 0 || ispunct(argv[i][optioncount] != 0) )  || argv[i][optioncount] != '\0' )
       {

             longoption[longoption_ch] = argv[i][optioncount];
             longoption_ch++;
 
       }

       //add NULL character to end of longoption
       longoption[longoption_ch] = '\0';


       //cant use switch for arrays, so use a bunch of IF statements
       if(strcmp(longoption, "print-stdout") == 0)
          printstdout = 1;

       else if(strcmp(longoption, "append-file") == 0)
        appendfile =1;
          
       else if(strcmp(longoption, "insert-query") == 0)
        call_function = 'i';  

       else if(strcmp(longoption, "delete-query") == 0)
        call_function = 'd';

       else if(strcmp(longoption, "update-query") == 0)
        call_function = 'u';

       
    

       else { printf("FLAG 2\n"); show_usage(argv[0]); exit(1); } 

  }

    
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

   } //end of for loop



//do some error checking to make sure users are using the options correclty
   
   //get input and output filenames / if user chose --print-stdout then dont look for an output filename
   if(printstdout == 1)
   {

               if(argc <= 4) //argc could be 3 if user uses "-ip" as option with no output file  
               {
                 useoutputfile = 0;       
                 sprintf(ctqfile, "%s", argv[--argc]);
               }

               if(argc == 5 || argc == 6)   //if user decides to do append the file then argc would be 6
               {
                 sprintf(out, "%s", argv[--argc]);
                 sprintf(ctqfile, "%s", argv[--argc]);
               }              

    }

    

    else //if user didn't select --print-stdout option
    {
        sprintf(out, "%s", argv[--argc]);
        sprintf(ctqfile, "%s", argv[--argc]);
    }


   
             //switch to call the functions
             switch(call_function)
             {

                 case 'i':
                 
                    insert_query();
                   break;

                 case 'u':
                    update_query();
                    break;

                 case 'd':
                    delete_query();
                    break;

                  default:
                     show_usage( argv[0] );
                     break;

               }



  return 0;
}


//when calling this function, just pass argv[0] because that is the program name
void show_usage(char *progname)
{

          printf("\n\nSQL Query Generator %.1f\t by Jonathan Harm\n", PROGRAM_VERSION);
          printf("\nusage: %s {-i -d -u} [OPTIONS] [CREATE TABLE FILE] [OUTPUT FILE]", progname);
          
          printf("\n\n\tOperation mode\t\t\tDescription\n");
          printf("\n\t-i, --insert-query\t\tmake an INSERT INTO query");
          printf("\n\t-u, --update-query\t\tmake an UPDATE query");
          printf("\n\t-d, --delete-query\t\tmake a DELETE query");
        
          printf("\n\n\n\n\tOption\t\t\t\tDescription\n");
          printf("\n\t-a, --append-file\t\tappend the output file");
          printf("\n\t-p, --print-stdout\t\tprint the output to the screen\n\n");
          
          exit(1);
}

